from tkinter import *
import tkinter
from tkinter.font import Font
import pickle

load("Dimension-Module.sage")
load("Enriques.1.1.sage")
load("SaitoInvariant.sage")
load("Composantes.sage")
load("Minimal.sage")
load("IrreCurve.sage")
load("Intersection.sage")
load("Arbre.sage")
load("Feuilletage.Min.sage")
load("Milnor.Saito.sage")
load("Saito.sage")
		
	
		
		
class CourbePlane(Tk):			
	def __init__(self,P,E,centre,direction,h,rayon,factor):
		Tk.__init__(self)

		self.title('Plane curves')

		self.windows=[]

		self.menubar=Menu(self)
		self.menu1=Menu(self, tearoff=0)
		self.menu1.add_command(label="Initialisation",command=self.remisezero)
		self.menu1.add_command(label="Initialisation with equation",command=self.initialisationEquation)
		self.menu1.add_separator()		
		self.menu1.add_command(label="Open",command=self.openarbre)		
		self.menu1.add_command(label="Save",command=self.savearbre)
		self.menu1.add_separator()		
		self.menu1.add_command(label="Quit", command=self.quitte)
		self.menubar.add_cascade(label="Fichier", menu=self.menu1)		
		self.menu2=Menu(self, tearoff=0)
		self.menu2.add_command(label="Algebraic multiplicity",command=self.affichevaluation)
		self.menu2.add_command(label="Milnor number",command=self.affichemilnor)
		self.menu2.add_command(label="Modularity",command=self.affichemodularite)
		self.menu2.add_separator()		
		self.menu2.add_command(label="Generic dimension of the moduli space",command=self.affichedimension)
		self.menu2.add_command(label="Generic Tjurina number",command=self.affichetjurina)
		self.menubar.add_cascade(label="Numerical Invariants", menu=self.menu2)
		self.menu3=Menu(self, tearoff=0)
		self.menu3.add_command(label="Saito dual graph",command=self.affichesaito)
		self.menu3.add_command(label="Saito Milnor number",command=self.affichesaitomilnor)		
		#self.menu3.add_command(label="Saito Theta1",command=self.afficheinvariantTheta1)
		#self.menu3.add_command(label="Saito Theta2",command=self.afficheinvariantTheta2)
		#self.menu3.add_command(label="Saito Theta2 Symetric",command=self.afficheinvariantTheta2Sym)
		#self.menu3.add_command(label="Saito Theta11",command=self.afficheinvariantTheta11)
		#self.menu3.add_command(label="Saito Theta11 Symetric",command=self.afficheinvariantTheta11Sym)
		self.menu3.add_command(label="Square invariant",command=self.affichesquare)
		self.menubar.add_cascade(label="Saito foliation", menu=self.menu3)
		self.menu4=Menu(self, tearoff=0)
		self.menu4.add_command(label="Proximity matrix",command=self.afficheproximite)		
		self.menu4.add_command(label="Intersection matrix",command=self.afficheintersection)
		self.menu4.add_command(label="Multiplicities matrix",command=self.affichemultiplicitiesmatrix)
		self.menu4.add_separator()		
		self.menu4.add_command(label="Topological types of irreducible components",command=self.affichecomponents)		
		self.menu4.add_command(label="Intersection multiplicities of components",command=self.afficheintersectioncomponents)
		self.menu4.add_command(label="Minimal graph",command=self.affichearbreminimal)			
		self.menu4.add_separator()		
		self.menu4.add_command(label="Enriques diagram",command=self.afficheEnriques)
		self.menubar.add_cascade(label="Dual graph", menu=self.menu4)
		self.menu6=Menu(self, tearoff=0)
		self.menu6.add_command(label="Semi group of valuations",command=self.affichesemigroup)		
		#self.menu6.add_command(label="Puiseux pairs")
		self.menu6.add_command(label="Puiseux parametrization",command=self.affichepuiseux)
		self.menubar.add_cascade(label="Irreducible curves", menu=self.menu6)
		self.menu7=Menu(self, tearoff=0)
		self.menu7.add_command(label="Initialisation")
		self.menu7.add_command(label="Minimal valuation foliation",command=self.minimalfolval)		
		self.menubar.add_cascade(label="Foliations", menu=self.menu7)
		self.menu8=Menu(self, tearoff=0)
		self.menu8.add_command(label="Commands",command=self.affichecommand)
		self.menu8.add_separator()
		self.menu8.add_command(label="Credits",command=self.affichecredits)		
		self.menubar.add_cascade(label="Help", menu=self.menu8)
		
		self.config(menu=self.menubar)		

		self.arbre=ArbreDual(P,E,[],[])		
		self.arbre.proximite=P
		self.arbre.etiquette=E
		self.arbre.racine=E[0]
		self.arbre.courbe=[[E[k],0] for k in range(0,self.arbre.taille())]
		
		self.centre=centre
		self.direction=direction
		self.h=h
		self.rayon=rayon
		self.factor=factor
		
		self.can=Canvas(self,width=1000,height=800,bg="white")
		self.dessin=DessinArbre(self.can,self.arbre,self.centre,self.direction,self.h,self.rayon,self.factor)
		self.dessin.graphecoordonnees_calcul()
		self.dessin.dessine()
		self.can.pack()
		
		self.can.bind("<Button-1>",self.blowup)
		self.can.bind("<Button-3>",self.addcourbe)
		self.can.bind("<B1-Motion>",self.deplace)
		self.bind("c",self.removecurve)
		self.bind("x",self.contract)				

		self.mainloop()

	def quitte(self):
		for widget in self.windows:
			try:
				widget.destroy()
			except:
				pass
		self.destroy()

	def savearbre(self):
		def recuperename():
			nom=entree.get()		
			fen.destroy()
			Data=open(nom,'wb')
			pickle.dump(self.arbre.proximite,Data)
			pickle.dump(self.arbre.etiquette,Data)			
			pickle.dump(self.arbre.racine,Data)
			pickle.dump(self.arbre.courbe,Data)
			pickle.dump(self.centre,Data)
			pickle.dump(self.direction,Data)
			pickle.dump(self.h,Data)
			pickle.dump(self.rayon,Data)
			pickle.dump(self.factor,Data)
			Data.close()
		
		fen=Tk()
		fen.title('File name')		
		entree = Entry(fen, width=30)
		entree.pack()

		bouton = Button(fen, text="Valider", command=recuperename)
		bouton.pack()
		fen.mainloop()
	
	def openarbre(self):
		def recuperename():
			nom=entree.get()		
			fen.destroy()
			Data=open(nom,'r')
			self.arbre.proximite=pickle.load(Data)
			self.arbre.etiquette=pickle.load(Data)
			self.arbre.racine=pickle.load(Data)
			self.arbre.courbe=pickle.load(Data)
			self.centre=pickle.load(Data)
			self.direction=pickle.load(Data)
			self.h=pickle.load(Data)
			self.rayon=pickle.load(Data)
			self.factor=pickle.load(Data)
			Data.close()
			self.can.delete("all")		
			self.dessin=DessinArbre(self.can,self.arbre,self.centre,self.direction,self.h,self.rayon,self.factor)
			self.dessin.graphecoordonnees_calcul()
			self.dessin.dessine()			

		fen=Tk()
		fen.title('File name')		
		entree = Entry(fen, width=30)
		entree.pack()

		bouton = Button(fen, text="Valider", command=recuperename)
		bouton.pack()
		fen.mainloop()				

	def blowup(self,event):
		cent=self.dessin.position(event.x,event.y)
		print(cent)				
		self.arbre.blowup(cent)
		self.can.delete("all")		
		self.dessin=DessinArbre(self.can,self.arbre,self.centre,self.direction,self.h,self.rayon,self.factor)
		self.dessin.graphecoordonnees_calcul()
		self.dessin.dessine()

	def contract(self,event):
		cent=self.dessin.position(event.x,event.y)				
		self.arbre.contract(cent)
		self.can.delete("all")		
		self.dessin=DessinArbre(self.can,self.arbre,self.centre,self.direction,self.h,self.rayon,self.factor)
		self.dessin.graphecoordonnees_calcul()
		self.dessin.dessine()

	def removecurve(self,event):	
		def geoliste(g):
    			r=[i for i in range(0,len(g)) if not g[i].isdigit()]
    			return [int(g[0:r[0]]),int(g[r[0]+1:r[1]]),int(g[r[1]+1:r[2]]),int(g[r[2]+1:])]
		pointeur=self.winfo_pointerxy()
		L,l,X,Y=geoliste(self.geometry())
		#print(pointeur[0]-X-10,pointeur[1]-Y-70)		
		cent=self.dessin.position(pointeur[0]-X-10,pointeur[1]-Y-70)			
		#print(cent)		
		if len(cent)==1: 
			self.arbre.removecurve(cent)		
			self.can.delete("all")
			self.dessin=DessinArbre(self.can,self.arbre,self.centre,self.direction,self.h,self.rayon,self.factor)
			self.dessin.graphecoordonnees_calcul()
			self.dessin.dessine()

	def addcourbe(self,event):
		#print(event.x,event.y)
		cent=self.dessin.position(event.x,event.y)			
		if len(cent)==1: 
			self.arbre.addcurve(cent)		
			self.can.delete("all")
			self.dessin=DessinArbre(self.can,self.arbre,self.centre,self.direction,self.h,self.rayon,self.factor)
			self.dessin.graphecoordonnees_calcul()
			self.dessin.dessine()
	
	def deplace(self,event):
		cent=self.dessin.position(event.x,event.y-2*self.rayon)
		if cent==[self.arbre.racine]:
			self.can.delete("all")		
			self.centre=[event.x,event.y-2*self.rayon]	
			self.dessin=DessinArbre(self.can,self.arbre,self.centre,self.direction,self.h,self.rayon,self.factor)
			self.dessin.graphecoordonnees_calcul()
			self.dessin.dessine()

	def remisezero(self):
		self.can.delete("all")
		self.arbre.proximite=[[1]]
		self.arbre.etiquette=[0]
		self.arbre.racine=0
		self.arbre.courbe=[[0,0]]
		self.dessin.graphecoordonnees_calcul()
		self.dessin.dessine()

##################


	def initialisationEquation(self):
		def recupere():
			self.equation=entree.get()
			self.fen.quit()			
			self.fen.destroy()

		self.fen=Tk()
		self.windows+=[self.fen]		
		self.fen.title('Equation')		
		
		Label(self.fen, text='Provide an equation in the variables x and y').grid(row=0,column=0,sticky=W)		
		entree = Entry(self.fen,width=70)
		entree.grid(row=0,column=1)					
		
		bouton = Button(self.fen, text="Valider", command=recupere)
		bouton.grid(row=1,column=0)
		
		self.fen.mainloop()
		
		#print(str(self.equation))
		
		R1=singular.ring(0,'(x,y)','dp')
		singular.lib('alexpoly.lib')
		f=singular(str(self.equation))
		A=singular.proximitymatrix(f)
		P=A[1].sage().transpose()
		I=A[2].sage().transpose()
		l=len(I[0])
		U=[i for i in range(0,l) if not I[i,i]==-1]
		V=[i for i in range(0,l) if I[i,i]==-1]
		CourbeNb=[sum([1 for i in V if P[j,i]==-1]) for j in U]
		Courbe=[[i,CourbeNb[i]] for i in range(0,len(U))] 
		Prox=[[P[i,j] for j in U] for i in U]
		if not Prox==[]:
			self.can.delete("all")
			self.arbre.proximite=Prox
			#print(self.arbre.proximite)
			self.arbre.etiquette=[l for l in range(0,len(U))]
			#print(self.arbre.etiquette)
			self.arbre.racine=Integer(0)
			#print(self.arbre.racine) 
			self.arbre.courbe=Courbe
			#print(self.arbre.courbe)
			self.arbre.listesousgraphe=[]
			self.dessin.graphecoordonnees_calcul()
			self.dessin.dessine()
		else:
			fen=Tk()
			self.windows+=[fen]		
			fen.title("Remark")
			can=Canvas(fen,width=400,height=100)
			can.create_text(10,50,text='The curve is smooth...',anchor='nw')
			can.pack()
			fen.mainloop()	

########################


	def affichecommand(self):
		fen=Tk()
		self.windows+=[fen]		
		fen.title("Commands")
		can=Canvas(fen,width=1000,height=400)
		can.create_text(10,50,text='left click = blow-up either a free point or a satellite (red dot)',anchor='nw')
		can.create_text(10,70,text='right click = add a strict transform (blue dot)',anchor='nw')
		can.create_text(10,90,text='key <x> = blow down a -1 component',anchor='nw')
		can.create_text(10,110,text='key <c> = remove a strict transform',anchor='nw')
		can.pack()
		fen.mainloop()	

	def affichecredits(self):
		fen=Tk()
		self.windows+=[fen]
		fen.title("Credits")
		can=Canvas(fen,width=300,height=100)
		can.create_text(150,20,text='PlanesCurves')
		can.create_text(150,40,text='by Yohann Genzmer')
		can.create_text(150,60,text='yohann.genzmer@math.univ-toulouse.fr')
		can.pack()
		fen.mainloop()
		
		
	def affichepuiseux(self):
		if sum([l[1] for l in self.arbre.courbe])==1:		
			Puiseux=IrreducibleCurve(self.arbre)
			Puiseux.parametrisation()
			Puiseux.normalisation(True)
			#Standard_Basis_O([Puiseux.param[0],Puiseux.param[1]],self.arbre.arbrecourbemilnor()+1)		
			fen=Tk()
			self.windows+=[fen]
			fen.title("Puiseux parametrization")
			can=Canvas(fen,width=1000,height=700)
			can.create_text(10,50,text='x='+str(Puiseux.param[0]),anchor='nw')
			can.create_text(150,50,text='y='+str(Puiseux.param[1]),anchor='nw',width=800)
			can.pack()
			fen.mainloop()
	
	def affichesemigroup(self):
			if sum([l[1] for l in self.arbre.courbe])==1:			
			#if method==0:			
			#	Puiseux=IrreducibleCurve(self.arbre)
			#	Puiseux.parametrisation()
			#	Puiseux.normalisation(False)
			#	print(Puiseux.param)
			#	A=semi_group([Puiseux.param[0],Puiseux.param[1]],self.arbre.arbrecourbemilnor())
			#else:
				B=SemiGroup(self.arbre)
				A=B.semi_group()	
				fen=Tk()
				self.windows+=[fen]
				fen.title("Generators of the semi-group")
				phrase='Generators of the semigroup = '+str(A)
				can=Canvas(fen,width=10*len(phrase),height=200)
				can.create_text(10,50,text='Generators of the semigroup = '+str(A),anchor='nw')
				can.create_text(10,70,text='Conductor = '+str(self.arbre.arbrecourbemilnor()),anchor='nw')			
				can.pack()
				fen.mainloop()
				
		
	def affichearbreminimal(self):
		if not sum([l[1] for l in self.arbre.courbe])==0:		
			fen=Tk()
			self.windows+=[fen]
			fen.title('Minimal desingularization')
			NewArbre=ArbreMinimal(deepcopy(self.arbre))
			NewArbre.minimize()
			can=Canvas(fen,width=1000,height=700)	
			dessin=DessinArbre(can,NewArbre.arbre,self.centre,self.direction,self.h,self.rayon,self.factor)
			dessin.graphecoordonnees_calcul()
			dessin.dessine()
			can.pack()
			fen.mainloop()		
	
	def affichecomponents(self):
		fen=Tk()
		self.windows+=[fen]
		fen.title('Topological types of irreducible components')
		can=Canvas(fen,width=1000,height=700)
		Comp=Components(self.arbre,can)
		Comp.listecomposante()
		Comp.dessinecomponents()	
		can.pack()
		fen.mainloop()
	
	def affichevaluation(self):
		fen=Tk()
		self.windows+=[fen]
		fen.title('Multiplicity')
		can=Canvas(fen,width=500,height=100)
		can.create_text(250,50,text='The algebraic multiplicity of the curve is '+str(self.arbre.arbrecourbevaluation())+'.')
		can.pack()
		fen.mainloop()
	
	def affichemilnor(self):
		fen=Tk()
		self.windows+=[fen]
		fen.title('Milnor number')
		can=Canvas(fen,width=500,height=100)
		can.create_text(250,50,text='The Milnor number of the curve is '+str(self.arbre.arbrecourbemilnor())+'.',font=Font(family='Liberation Serif', size=12))
		can.pack()
		fen.mainloop()

	def affichemodularite(self):
		fen=Tk()
		self.windows+=[fen]
		fen.title('Modularity')		
		can=Canvas(fen,width=500,height=100)
		can.create_text(250,50,text='The modularity of the curve is '+str(self.arbre.arbrecourbemodularite())+'.',font=Font(family='Liberation Serif', size=12))
		can.pack()
		fen.mainloop()

	def affichetjurina(self):
		fen=Tk()
		self.windows+=[fen]
		fen.title('Generic Tjurina number')
		can=Canvas(fen,width=500,height=100)
		can.create_text(250,50,text='The generic Tjurina number of the curve is '+str(self.arbre.arbrecourbetjurina())+'.',font=Font(family='Liberation Serif', size=12))
		can.pack()
		fen.mainloop()
	
	def affichedimension(self):
		fen=Tk()
		self.windows+=[fen]
		fen.title('Generic dimension of the moduli space')
		can=Canvas(fen,width=500,height=100)
		can.create_text(250,50,text='The generic dimension of the moduli space is '+str(self.arbre.arbrecourbedimension())+'.',font=Font(family='Liberation Serif', size=12))
		can.pack()
		fen.mainloop()

	def affichesaito(self):
		dicriticite=Saito(self.arbre.proximite,triEtiquette(deepcopy(self.arbre.courbe)))
		fen=Tk()
		self.windows+=[fen]
		fen.title('Saito foliation')	
		can=Canvas(fen,width=1000,height=800,bg="white")
		can.create_text(200,50,text='Multiplicity of the curve = '+str(self.arbre.arbrecourbevaluation()), anchor='w')
		if dicriticite[0][1]==0:
			can.create_text(200,75,text='The Saito foliation is dicritical', anchor='w')
			can.create_text(200,100,text='Multiplicity of the Saito foliation = '+str(floor(self.arbre.arbrecourbevaluation()/2)-1+int(mod(self.arbre.arbrecourbevaluation(),2))), anchor='w')
			#can.create_text(200,125,text=str(EpsilonSaito(self.arbre.proximite,triEtiquette(deepcopy(self.arbre.courbe)))), anchor='w')		
		else:
			can.create_text(200,75,text='The Saito foliation is not dicritical', anchor='w')
			can.create_text(200,100,text='Multiplicity of the Saito foliation = '+str(floor(self.arbre.arbrecourbevaluation()/2)), anchor='w')
			#can.create_text(200,125,text=str(EpsilonSaito(self.arbre.proximite,triEtiquette(deepcopy(self.arbre.courbe)))), anchor='w')
		
		arbresaito=ArbreDual(self.arbre.proximite,self.arbre.etiquette,self.arbre.racine,self.arbre.courbe)
		dessinsaito=DessinArbre(can,arbresaito,self.centre,self.direction,self.h,self.rayon,self.factor)
		dessinsaito.graphecoordonnees_calcul()
		dessinsaito.dessinesaito(dicriticite,True,False)		
		can.pack()
		fen.mainloop()
		
	def affichesaitomilnor(self):
		dicriticite=Saito(self.arbre.proximite,triEtiquette(deepcopy(self.arbre.courbe)))
		print(dicriticite)
		m=len(dicriticite)
		fen=Tk()
		self.windows+=[fen]
		fen.title('Milnor number of the Saito foliation')
		can=Canvas(fen,width=500,height=100)
		can.create_text(250,50,text='The Milnor number of the Saito foliation is '+str(MilnorSaito(self.arbre.proximite,self.arbre.etiquette,self.arbre.racine,[[dicriticite[l][0],dicriticite[l][2]] for l in range(0,m)],[[dicriticite[l][0],dicriticite[l][1]] for l in range(0,m)])),font=Font(family='Liberation Serif', size=12))
		can.pack()
		fen.mainloop()
		
		
		

	def afficheintersectioncomponents(self):
		def recupere():
			self.eti1=int(entree.get())
			self.eti2=int(entree2.get())		
			self.fen.quit()			
			self.fen.destroy()

		
		self.fen=Tk()
		self.windows+=[self.fen]		
		self.fen.title('Label')		
		
		Label(self.fen, text="First component").grid(row=0,column=0,sticky=W)		
		Label(self.fen, text="Second component").grid(row=1,column=0,sticky=W)				
		entree = Entry(self.fen)				
		entree2 = Entry(self.fen)	
		entree.grid(row=0,column=1)
		entree2.grid(row=1,column=1)	

		bouton = Button(self.fen, text="Valider", command=recupere)
		bouton.grid(row=2,column=1)

		self.fen.mainloop()

		fen=Tk()
		fen.title('Multiplicity of intersection')
		self.windows+=[fen]		
		B=Intersection(self.arbre,self.eti1,self.eti2)
		v=B.intersection()
		can=Canvas(fen,width=500)
		can.create_text(10,10,text='The multiplicity of intersection of the two components is '+str(v),anchor='nw')
		can.pack()
		fen.mainloop()	


	def afficheinvariantTheta1(self):
		A=SaitoInvariant(self.arbre,self.arbre.courbe,self.centre,self.direction,self.h,self.rayon,self.factor)
		A.entreeetiacces()

	def afficheinvariantTheta2(self):
		A=SaitoInvariant(self.arbre,self.arbre.courbe,self.centre,self.direction,self.h,self.rayon,self.factor)
		A.entreeetiacces2()
		
	def afficheinvariantTheta2Sym(self):
		A=SaitoInvariant(self.arbre,self.arbre.courbe,self.centre,self.direction,self.h,self.rayon,self.factor)
		A.entreeetiacces2sym()
		
	def afficheinvariantTheta11Sym(self):
		A=SaitoInvariant(self.arbre,self.arbre.courbe,self.centre,self.direction,self.h,self.rayon,self.factor)
		A.entreeetiacces3sym()
		
	def affichesquare(self):	
		A=SaitoInvariant(self.arbre,self.arbre.courbe,self.centre,self.direction,self.h,self.rayon,self.factor)
		A.square()	
		
	def afficheinvariantTheta11(self):
		A=SaitoInvariant(self.arbre,self.arbre.courbe,self.centre,self.direction,self.h,self.rayon,self.factor)
		A.entreeetiacces3()

	def afficheproximite(self):
		print(self.arbre.proximite)
		fen=Tk()
		self.windows+=[fen]
		fen.title('Proximity matrix')
		can=Canvas(fen,width=100+20*self.arbre.taille(),height=20*self.arbre.taille())
		can.create_text(10,10,text=matrix(self.arbre.proximite).str(),anchor='nw')
		can.pack()
		fen.mainloop()

	def afficheintersection(self):
		fen=Tk()
		self.windows+=[fen]
		fen.title('Intersection matrix')
		can=Canvas(fen,width=100+20*self.arbre.taille(),height=20*self.arbre.taille())
		can.create_text(10,10,text=matrix(self.arbre.intersection()).str(),anchor='nw')
		can.pack()
		fen.mainloop()
		
	def affichemultiplicitiesmatrix(self):
		fen=Tk()
		self.windows+=[fen]
		fen.title('Multiplicities matrix')
		can=Canvas(fen,width=100+20*self.arbre.taille(),height=20*self.arbre.taille())
		can.create_text(10,10,text=(matrix(self.arbre.proximite).inverse()).str(),anchor='nw')
		can.pack()
		fen.mainloop()

	def afficheEnriques(self):
		def deplace(event):
			can.delete("all")					
			En=EnriquesDiagram(can,self.arbre,[event.x,event.y],100,8,[0,1],100)
			En.graphecoordonnees_calcul()				

		fen=Tk()
		self.windows+=[fen]
		fen.title('Enriques diagram')
		can=Canvas(fen,width=1000,height=800,bg="white")
		En=EnriquesDiagram(can,self.arbre,[500,400],100,8,[0,1],100)
		En.graphecoordonnees_calcul()		
		#can.bind("<Button-1>",deplace)
		can.pack()
		
		#value = DoubleVar()
		#scale = Scale(fen, variable=value, from_=100, to=200, orient=HORIZONTAL,width=200)
		#scale.pack()
		
		def redraw():
			can.delete("all")		
			En=EnriquesDiagram(can,self.arbre,[event.x,event.y],scale.get(),8,[0,1],100)
			En.graphecoordonnees_calcul()

		#b = Tkinter.Button(fen, text="Redraw", command=redraw, anchor=NW,width=200)
		#b.pack()

		fen.mainloop()
		
		
		
		######### 
		
	def minimalfolval(self):
		A=ArbreDualFeuilletage(self.arbre.proximite,self.arbre.etiquette,self.arbre.racine,self.arbre.courbe,[[l,1] for l in self.arbre.etiquette])
		Res=A.feuilletageminimal3()
		
		fen=Tk()
		self.windows+=[fen]
		fen.title('Foliation with minimal Saito number')	
		can=Canvas(fen,width=1000,height=800,bg="white")
		can.create_text(200,50,text='Multiplicity of the foliation = '+str(Res[2]), anchor='w')
		arbresaito=ArbreDual(A.proximite,A.etiquette,A.racine,Res[1])
		dessinsaito=DessinArbre(can,arbresaito,self.centre,self.direction,self.h,self.rayon,self.factor)
		dessinsaito.graphecoordonnees_calcul()
		
		V=[Res[0][l]+[Res[0][l][1]*Res[1][l][1]] for l in range(0,len(Res[0]))]
		
		dessinsaito.dessinesaito(V,True,True)		
		can.pack()
		fen.mainloop()

class DessinArbre():
	def __init__(self,can,arbre,centre,direction,h,rayon,factor):
		self.can=can
		self.arbre=arbre		
		self.centre=centre
		self.direction=direction
		self.rayon=rayon
		self.factor=factor
		self.h=h		
		self.listedessinarbre=[]

	def rotation(self,angle,centre,pt):
		return([cos(angle)*(-centre[0]+pt[0])-sin(angle)*(-centre[1]+pt[1])+centre[0],sin(angle)*(-centre[0]+pt[0])+cos(angle)*(-centre[1]+pt[1])+centre[1]])

	def graphecoordonnees_calcul(self):
		self.arbre.sousgraphe()		
		self.graphecoordonnees=[[],[]]		
		if self.arbre.taille()==1:
			self.graphecoordonnees[0]=self.graphecoordonnees[0]+[[self.arbre.racine,self.centre,self.rayon]]
		else:
			self.graphecoordonnees[0]=self.graphecoordonnees[0]+[[self.arbre.racine,self.centre,self.rayon]]
			self.NbSommet=len(self.arbre.listesousgraphe)
			#print(NbSommet)
			self.angle=2*math.pi/(self.NbSommet+1)		

			self.centre1=[self.centre[k]+self.h*self.direction[k] for k in range(0,2)]
			#print(centre1)
			for u in range(0,self.NbSommet):
				self.centre1=self.rotation(self.angle,self.centre,self.centre1)
				self.direction1=[1/self.h*(self.centre[k]-self.centre1[k]) for k in range(0,2)]
				
				self.graphecoordonnees[1]=self.graphecoordonnees[1]+[[self.arbre.racine,self.arbre.listesousgraphe[u].racine,self.centre,self.centre1]]

				self.listedessinarbre.append(DessinArbre(self.can,self.arbre.listesousgraphe[u],self.centre1,self.direction1,self.h/self.factor,self.rayon/self.factor,self.factor))

				self.listedessinarbre[u].graphecoordonnees_calcul()

				self.graphecoordonnees[0]=self.graphecoordonnees[0]+self.listedessinarbre[u].graphecoordonnees[0]
				self.graphecoordonnees[1]=self.graphecoordonnees[1]+self.listedessinarbre[u].graphecoordonnees[1]
	
	def dessine(self):
		def sommet(centre,rayon,color):
			self.can.create_oval(centre[0]-rayon,centre[1]-rayon,centre[0]+rayon,centre[1]+rayon,fill=color)
		def milieu(pt1,pt2):
			return([(pt1[0]+pt2[0])/2,(pt1[1]+pt2[1])/2])				
		def arete(pt1,pt2):
			self.can.create_line(pt1[0],pt1[1],pt2[0],pt2[1])
			sommet(milieu(pt1,pt2),self.rayon/4,"red")
		#print(self.graphecoordonnees)
		for l in self.graphecoordonnees[0]:
			sommet(l[1],l[2],"black")
		for a in self.graphecoordonnees[1]:
			arete(a[2],a[3]) 
			

		for l in range(0,self.arbre.taille()):			
			self.can.create_text(self.graphecoordonnees[0][l][1][0],self.graphecoordonnees[0][l][1][1],text=str(self.graphecoordonnees[0][l][0])+','+str(self.arbre.valuation(self.graphecoordonnees[0][l][0])),fill="white")

		for l in self.arbre.courbe:
			nombre=l[1]
			rang=[self.graphecoordonnees[0][a][0] for a in range(0,self.arbre.taille())].index(l[0]) 			
			if not nombre==0:
				suitecentre=deepcopy(self.graphecoordonnees[0][rang][1])
				rayoncourbe=self.graphecoordonnees[0][rang][2]
				anglecourbe=2*math.pi/nombre
				suitecentre[0]=suitecentre[0]+rayoncourbe					
				for u in range(0,nombre):
					suitecentre=self.rotation(anglecourbe,self.graphecoordonnees[0][rang][1],suitecentre)
					sommet(suitecentre,rayoncourbe/5,"blue")

	def dessinesaito(self,dicriticite,boo,boo2):
		def sommet(centre,rayon,color):
			self.can.create_oval(centre[0]-rayon,centre[1]-rayon,centre[0]+rayon,centre[1]+rayon,fill=color)
		def milieu(pt1,pt2):
			return([(pt1[0]+pt2[0])/2,(pt1[1]+pt2[1])/2])				
		def arete(pt1,pt2):
			self.can.create_line(pt1[0],pt1[1],pt2[0],pt2[1])
		
		for a in self.graphecoordonnees[1]:
			arete(a[2],a[3]) 

		for l in self.graphecoordonnees[0]:
			eti=[dicriticite[u][0] for u in range(0,len(dicriticite))].index(l[0])
			if dicriticite[eti][1]==1:
				sommet(l[1],l[2],"white")
			else:
				sommet(l[1],l[2],"grey")

		if boo==True:		
			for l in self.graphecoordonnees[0]:
				eti=[dicriticite[u][0] for u in range(0,len(dicriticite))].index(l[0])
				nombre=dicriticite[eti][2]
				rang=[self.graphecoordonnees[0][a][0] for a in range(0,self.arbre.taille())].index(l[0]) 			
				if not nombre==0:
					suitecentre=deepcopy(self.graphecoordonnees[0][rang][1])
					rayoncourbe=self.graphecoordonnees[0][rang][2]
					anglecourbe=2*math.pi/nombre
					suitecentre[0]=suitecentre[0]+rayoncourbe*10/9					
					for u in range(0,nombre):
						suitecentre=self.rotation(anglecourbe,self.graphecoordonnees[0][rang][1],suitecentre)
						sommet(suitecentre,rayoncourbe/5,"black")
		
		if boo2==True:
			for l in range(0,self.arbre.taille()):	
				self.can.create_text(self.graphecoordonnees[0][l][1][0],self.graphecoordonnees[0][l][1][1],text=str(self.graphecoordonnees[0][l][0])+','+str(self.arbre.valuation(self.graphecoordonnees[0][l][0])),fill="black")
		else:
			for l in range(0,self.arbre.taille()):	
				self.can.create_text(self.graphecoordonnees[0][l][1][0],self.graphecoordonnees[0][l][1][1],text=str(self.graphecoordonnees[0][l][0]),fill="black")

		
	def position(self,x,y):
		def milieu(pt1,pt2):
			return([(pt1[0]+pt2[0])/2,(pt1[1]+pt2[1])/2])			
		def dist(p1,p2):
			return(sqrt((p1[0]-p2[0])^2+(p1[1]-p2[1])^2))
		Sortie=[]		
		Dist=[dist([x,y],l[1]) for l in self.graphecoordonnees[0]]
		DistArete=[dist([x,y],milieu(a[2],a[3])) for a in self.graphecoordonnees[1]]
		Sortie1=[self.graphecoordonnees[0][p][0] for p in range(0,len(Dist)) if Dist[p]<=self.graphecoordonnees[0][p][2]]
		Sortie2=[self.graphecoordonnees[1][u][0:2] for u in range(0,len(DistArete)) if DistArete[u]<=self.graphecoordonnees[0][0][2]/2]
		if not Sortie2==[]:
			Sortie2=Sortie2[0]		
		#print("sortie",Sortie1+Sortie2)
		return(Sortie1+Sortie2)

	
	

f=CourbePlane([[1]],[0],[500,500],[0,1],90,15,1)
	

