##############################################
##############################################
#####  Calcul le feuilletage de Saito d'une courbe
##############################################
#Pour l'appeler, il faut donner la matrice de proximité de la réduction et le nombres de composantes de S par diviseur irréductible. 

from copy import copy

##################  Fonction basiques

#### Calcule les composantes d'un éclatement au-dessus du premier éclatement
def ComposanteEclatement(i,L):
	def Position(L):
		return([j for j in range(0,len(L)) if L[j]==-1]) 
	Res=[]	
	ADD1=[i]		
	ADD2=[i]
	while not ADD2==[]:
		#print(ADD2)		
		Res=Res+ADD2
		ADD2=[]
		for l in ADD1:
			ADD2=ADD2+Position(L[l])
		ADD1=ADD2
	Res=list(set(Res))
	Res.sort()	
	return(Res)


def Pluspetitabsent(L,k):
	def ConcatSort(L):
		P=[]	
		for l in L:
			P=P+l
		return(sorted(P))
	L=ConcatSort(L)
	if len(L)==L[-1]:
		if L[-1]<k:
			return(L[-1]+1)
		else:
			return(0)
	else:
		i=1		
		while i==L[i-1]:
			i=i+1
		return(i) 

def triEtiquette(L):
	if L==[]:
		return([])
	else:
		turn=min([l[0] for l in L])
		place=[l[0] for l in L].index(turn)
		Val=L[place]
		L.remove(L[place])		
		return([Val]+triEtiquette(L))

def Decomposition(L):
	l=len(L)
	Res=[ComposanteEclatement(1,L)]	
	min=Pluspetitabsent(Res,l-1)
	while not min==0:
		Res=Res+[ComposanteEclatement(min,L)]
		min=Pluspetitabsent(Res,l-1)
	return(Res)

def Extract(M,L):
	return([[M[i][j] for j in L] for i in L])

def EclatementDecomposition(M,etiquette):
	L=Decomposition(M)
	U=Voisinage(M,0)
	Res=[]	
	for l in L:
		i=0
		while (U[i] in l)==False:
			i=i+1
		Res=Res+[U[i]]   
	Res1=[Extract(M,l) for l in L]
	Res2=[]
	Res3=[]	
	for l in L:
		Res2=Res2+[[etiquette[i] for i in l]]
	Res3=[etiquette[i] for i in Res]
	return([Res1,Res2,Res3])
	#Res1 est une la liste des matrices de proximités des sous-éclatements
	#Res2 est la liste des liste d'étiquettes associées
	#Res3 est l'étiquette qui correspond à la composante de rattachement à la composante initiale

def Sommev(L):
	Res=0	
	for l in L:
		Res=Res+l
	return(Res)

def Valuation(M,nu):
	P=matrix(M).inverse()[0,:]
	P=P.list()
	return(Sommev([P[i]*nu[i][1] for i in range(0,len(nu))]))

def Voisinage(M,i):
	P=-matrix(M)*matrix(M).transpose()
	return([j for j in range(0,len(M)) if P[i][j]==1])

def ValuationFeuilletage(M,deltanu):
	Res=[]	
	for i in range(0,len(deltanu)):
		if deltanu[i][0]==1:
			Res=Res+[deltanu[i][1]]
		if deltanu[i][0]==0:
			V=Voisinage(M,i)
			ValNonDic=len([l for l in V if deltanu[l][0]==1])
			Res=Res+[2-ValNonDic+deltanu[i][1]]
	P=matrix(M).inverse()[0,:]
	P=P.list()
	return(Sommev([P[i]*Res[i] for i in range(0,len(deltanu))])-1)

def ExtraireValuation(etiquette,nu):
	Res=[]
	V=[l[0] for l in nu]
	for l in etiquette:
		Res=Res+[nu[V.index(l)]]
	return(Res)



##########################################################################################		
################ Compute the topology of the Saito foliation for a given proximity matrix M and a distribution of irreducible components nu. 
def Saito(M,nu):
	ValCourbe=Valuation(M,nu)
	if M==[[1]]:
		if nu[0][1]==0:
			print('Eclatements inutiles')
		else:
			if nu[0][1]<=2: 
				#print([[nu[0][0],1,nu[0][1]]])
				return([[nu[0][0],1,nu[0][1]]])
			else:
				#print([[nu[0][0],0,ceil(nu[0][1]/2)-2]])
				return([[nu[0][0],0,ceil(nu[0][1]/2)-2]])
	else:
		DecompEcla=EclatementDecomposition(M,[l[0] for l in nu])	
		######################################################	
		### Le cas dicritique	
		Res=[]			
		for i1 in range(0,len(DecompEcla[2])):			
			#print(nu)			
			Newnu=ExtraireValuation(DecompEcla[1][i1],nu)	
			P=Saito(DecompEcla[0][i1],Newnu)
			Res=Res+P				
		Res=triEtiquette(Res)	
		ValDic=ValuationFeuilletage(M,[[0,0]]+[l[1:3] for l in Res])
		if ceil(ValCourbe/2)-1-ValDic>=0:
			#print([[nu[0][0],0,ceil(ValCourbe/2)-1-ValDic]]+Res)
			return([[nu[0][0],0,ceil(ValCourbe/2)-1-ValDic]]+Res)
		else:
			#########################################
			#### Le cas non dicritique				
			Res=[]				
			for i2 in range(0,len(DecompEcla[2])):
				nuu=deepcopy(nu)
				Newnu=ExtraireValuation(DecompEcla[1][i2],nuu)
				for j in range(0,len(Newnu)):
					if Newnu[j][0]==DecompEcla[2][i2]:
						Newnu[j][1]=Newnu[j][1]+1		
				P=Saito(DecompEcla[0][i2],Newnu)
				Res=Res+P				
			Res=triEtiquette(Res)	
			for l1 in DecompEcla[2]:
				for j1 in range(0,len(Res)):
					if Res[j1][0]==l1 and Res[j1][1]==1:
						Res[j1][2]-=1	
			ValNonDic=ValuationFeuilletage(M,[[1,0]]+[l[1:3] for l in Res])		
			#print([[nu[0][0],1,floor(ValCourbe/2)-ValNonDic]]+Res)
			return([[nu[0][0],1,floor(ValCourbe/2)-ValNonDic]]+Res)	



def EpsilonSaito(M,nu):
	D=Saito(M,nu)
	print(D)
	Vois=[Voisinage(M,i) for i in [d[0] for d in D]]
	print(Vois)
	ValenceNonDic=[sum([D[i][1] for i in V]) for V in Vois]
	print(ValenceNonDic)
	Res=[[l[0],l[2]] for l in D]
	print('Res=',Res)
	for i in range(0,len(Res)):
		if D[i][1]==0:
			Res[i][1]+=2-ValenceNonDic[i]
	return(Res)

#####################################################################
################### Summarize the computations of the Saito foliation

def CalculSaito(M,nu):
	V=Valuation(M,nu)	
	Resultat=Saito(M,nu)
	
	print('RESULTAT')
	print('--------------------------------------------------')
	print('Valuation de la courbe=',V)
	if Resultat[0][1]==0:
		print('Le feuilletage de Saito est dicritique')
		print('Valuation attendue =',ceil(V/2)-1)
	else:
		print('Le feuilletage de Saito est non dicritique')
		print('Valuation attendue =',floor(V/2))
	print('Arbre de Saito=',Resultat)
	print('Valuation de Saito =',ValuationFeuilletage(M,[l[1:3] for l in Resultat]))


