################ Module de calcul pour une branche irréductible du plan

############## Declaration de l'anneau dans lequel le calcul est fait

R.<t>=QQ[]

############ Resolution d'un système linéaire selon l'algo de Cojean & Devie

def Ordre(L1,L2):
	Test1=sum([1 for i in range(0,len(L1)) if L1[i]<L2[i]])
	if Test1>0:
		return(0)	
	elif L1==L2:
		return(0)
	else:
		return(1)
	
def OrderGen(x,L):
	Test=sum([1 for s in L if Ordre(x,s)==1])
	if Test>0:
		return(0)
	else:
		return(1)

def EvalLinear(L,e):
	return(sum([L[i]*e[i] for i in range(0,len(L))]))

def CanonicalBasis(n):
	Zero=[[0 for i in range(0,n)] for i in range(0,n)]
	for i in range(0,n):
		Zero[i][i]=1
	return([tuple(a) for a in Zero])

def Somme(A,B):
	return(tuple([A[i]+B[i] for i in range(0,len(A))]))
	
def ContejeanLinear(L):
	P=CanonicalBasis(len(L))
	Can=P	
	#print(P)	
	B=[]
	count=0
	while P!=[] :
		B=list(set(B).union(set([x for x in P if EvalLinear(L,x)==0])))
		#print(B)		
		
		D=list(set(P).difference(set(B)))
		#print(D)
	
		U=[x for x in list(D) if OrderGen(x,B)==1]
		#print(U)
		
		P=[]		
		for x in U:
			P=P+[Somme(x,Can[i]) for i in range(0,len(Can)) if EvalLinear(L,x)*L[i]<0]
		print(P)
		count=count+1
	return(B)

def ContejeanAffine(L,B):
		return([l[1:] for l in ContejeanLinear([-B]+L) if l[0]==1])


####################################### Resolution d'une équation diophantienne particulière. 
def Diophantine_Solveur(L,m):
	p = MixedIntegerLinearProgram()
	w = p.new_variable(integer=True, nonnegative=True)
	Eq=sum([Integer(L[i])*w[i] for i in range(0,len(L))])	
	p.add_constraint(Eq == Integer(m))
	return(list(p.polyhedron().integral_points()))


###########################################"

def order_valuation(L):
	if (len(L)==0 or len(L)==1): 
		return(L)
	else:
		if len(L)==2:
			if L[0].valuation()<=L[1].valuation():
				return(L)
			else: 
				L.reverse()					
				return(L)
		else: 
			LL=order_valuation(L[0:-1])
			return( [p for p in LL if p.valuation()<=L[-1].valuation()]+[L[-1]]+[p for p in LL if p.valuation()>L[-1].valuation()])


def clean(L):
	while 0 in L:
		L.remove(0)
	return(L)

def Sprocess(L,cond):
	val=[l.valuation() for l in L]
	coeff=[l.monomial_coefficient(t^l.valuation()) for l in L]
	print('Entrée dans Conte-Jean')
	Sol=ContejeanLinear([-l for l in val]+val)
	print('Sortie de Conte-Jean')
	Res=[]
	
	for v in Sol:
		val1=v[0:len(L)]
		val2=v[len(L):]
		if val1!=val2:
			product=prod([L[i]^val1[i]/coeff[i]^val1[i] for i in range(0,len(L))])-prod([L[i]^val2[i]/coeff[i]^val2[i] for i in range(0,len(L))])
			product=product.truncate(cond)					
			if product!=0:
				Res+=[product]
	
	Res=order_valuation(Res)	
	print('Longueur ajout = ',len(Res))	
	Res2=L		
	for l in Res:
		if Reduction_finale(l,Res2,cond)!=0:
			Res2+=[l] 
	
	return(Res2)


#################################################
# Calcul d'une base de O
#################################################

########################################### Calcul une réduction de F modulo G
def Reduction(F,G,Cond):
	m=F.valuation()
	D=F.monomial_coefficient(t^m)
	L=[g.valuation() for g in G]	
	DLL=[g.monomial_coefficient(t^(g.valuation())) for g in G]
	Res=Diophantine_Solveur(L,m)
	#print(Res)
	if Res==[]:
		return(F)
	else:
		sol=list(Res[-1])		
		return((F-D*prod([G[i]**sol[i] for i in range(0,len(sol)) if sol[i]>0])/prod([DLL[i]**sol[i] for i in range(0,len(sol)) if sol[i]>0])).truncate(Cond))

############################################ Calcul de la réduction finale
def Reduction_finale(F,G,M):
	Res=F
	while (Res.valuation()<M and Res!=0):
		Res1=Reduction(Res,G,M)		
		if Res1==Res:		
			break
		else:		
			Res=Res1
	if Res.valuation()>=M:
		print('Done')		
		return(0)
	else:
		print('Done')
		return(Res)

################################ Calcul la base standard du module d'une branche		

def semi_group(F,cond):
		
	Res=F
	lg1=0
	lg2=len(F)
	while lg1!=lg2:		
		lg1=lg2		
		Res=Sprocess(Res,cond)
		lg2=len(Res)
	
	return([l.valuation() for l in Res])


##################################################  Autre procédure pour le semigroup fondée sur le livre de Casas-Alvero

class SemiGroup():
	def __init__(self,arbre):
		self.arbremin=ArbreMinimal(deepcopy(arbre))

	def etiquettebranchement(self):
		self.arbremin.minimize()
		return([l for l in self.arbremin.arbre.etiquette[0:-1] if len(self.arbremin.arbre.proximate(l))==1 and len(self.arbremin.arbre.proximate(self.arbremin.arbre.etiquette[self.arbremin.arbre.etiquette.index(l)+1]))==2])

	def semi_group(self):
		L=self.etiquettebranchement()
		#print(L)		
		Res=[]		
		for l in L:
			Inter=Intersection(self.arbremin.arbre,l,self.arbremin.arbre.etiquette[-1])
			Res+=[Inter.intersection()]
		return([self.arbremin.arbre.valuation(self.arbremin.arbre.etiquette[-1])]+Res)


			


